/*
 * Created on 2004/10/04
 *
 */
package jp.co.intra_mart.foundation.security.certification;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;

import jp.co.intra_mart.common.aid.jdk.java.lang.StringUtil;
import jp.co.intra_mart.foundation.security.account.Account;
import jp.co.intra_mart.foundation.security.account.AccountManager;
import jp.co.intra_mart.foundation.security.exception.AccessSecurityException;

/**
 * SSÕOCNGXg̓NXB <BR>
 * <BR>
 * ActiveDirectoryƘASSOOCNGXg̓NXłB<br>
 * <br>
 * @since 5.0
 * @author INTRAMART
 * @version 1.0
 */
public class ADRequestAnalyzer extends StandardRequestAnalyzer {


    private static final String ID_SEPARATOR = "\\\\"; 

    public static final String SSO_LOGOUT_URL = "sso-logout-url";




    private String ssoLogoutUrl = StringUtil.EMPTY_STRING;

    public ADRequestAnalyzer() {
        super();
    }

    /**
     * OCNGXgAiCȔB <BR>
     * <BR>
     * ̃NXNX鎞Ax̃\bhĂяoB
     * 
     * @param params
     *            p[^̃}bv(Map)
     */
    public void init(Map params) {
        super.init(params);
        if(params.containsKey(SSO_LOGOUT_URL)){
           this.ssoLogoutUrl =  (String)params.get(SSO_LOGOUT_URL);
        }
    }

    /**
     * NGXgp[^̉́B <BR>
     * <BR>
     * NGXg͂ăOCԋp܂B
     * 
     * @param loginInfo
     *            x[XƂȂ郍OCNGXg <BR>
     *            T[ubgNGXg(request)擾̃p[^(loginRequestInfo)̃vpeBɐݒ肵ĕԋpB
     * @param request
     *            HTTPT[ubgNGXg
     * @return OC
     */
    public LoginInfo parseRequest(LoginRequestInfo loginInfo, HttpServletRequest request) {

        loginInfo = (LoginRequestInfo) super.parseRequest(loginInfo, request);

        // 񏉊
        loginInfo.setUser(StringUtil.EMPTY_STRING);
        loginInfo.setPassword(StringUtil.EMPTY_STRING);

        //F؏񂩂烆[Uhc擾
        //uhC\[UIDvŎ擾
        String userName = request.getUserPrincipal().getName();
        String[] usernames = userName.split(ID_SEPARATOR);
        if (usernames.length > 1) {
            loginInfo.setUser(usernames[1]);
        }
        
        // pX[h擾B
        try {
            AccountManager manager = new AccountManager(loginInfo.getLoginGroup());
            Account account = manager.getAccount(loginInfo.getUser());
            loginInfo.setPassword(account.getPassword());
            // SSOOAEgURL݂ȂAURLɐݒ肵܂B
            if(this.ssoLogoutUrl.length() > 0) {
                    loginInfo.setInitialUrl(this.ssoLogoutUrl);
            }
        } catch (AccessSecurityException e1) {
            // ɗ烍OCłȂI
            // ɑs
        } catch (Exception e) { } 

        return loginInfo;
    }

}